<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                template="/plantilla-principal.xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
        <h1>Administrar Permisos</h1>
        <div class="ui stackable grid">
            <div class="sixteen wide column">
                <div>
                    <div class="ui fluid icon input search">
                        <input id="txtBuscar" placeholder="Buscar" type="text"></input>
                        <i class="search icon"></i>
                    </div>
                </div>
            </div>
            <div id="scroll" class="scroll">
                <h:form id="form-tabla">
                    <table jsf:id="elementos-tabla" class="ui basic selectable celled table" width="700px">
                    <!--<table jsf:id="elementos-tabla" class="ui very basic simple selectable celled table" width="700px">-->
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>Funcionario</th>
                                <th>Cargo</th>
                                <th>CI</th>
                                <th>Permisos</th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{permisoManBean.funcionarios}" var="funcionarios" varStatus="funcionariosStatus">
                                <tr id="func#{funcionarios.idfuncionario}">
                                    <input name="selbar" id="selbar" type="hidden" jsf:value="#{permisoManBean.seleccionIDJSON}"/>
                                    <td id="column-id-funcionario-#{funcionarios.idfuncionario}" onclick="seleccionarFuncionario('#{funcionarios.idfuncionario}')">#{funcionarios.idfuncionario}</td>
                                    <td id="column-nombre-funcionario-#{funcionarios.idfuncionario}" onclick="seleccionarFuncionario('#{funcionarios.idfuncionario}')">#{funcionarios.nombres} #{funcionarios.apellidos}</td>
                                    <td id="columns-cargo-funcionario-#{funcionarios.idfuncionario}" onclick="seleccionarFuncionario('#{funcionarios.idfuncionario}')">#{funcionarios.cargo.nombre}</td>
                                    <td id="column-ci-funcionario-#{funcionarios.idfuncionario}" onclick="seleccionarFuncionario('#{funcionarios.idfuncionario}')">#{funcionarios.ci}</td>
                                    <td id="column-action-funcionario#{funcionarios.idfuncionario}">
                                        <h:commandLink onclick="seleccionarFuncionario('#{funcionarios.idfuncionario}')">
                                            <i class="settings icon"></i><f:ajax execute="@form" render="form-tabla-modulo"/>
                                        </h:commandLink>
                                    </td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                    </table>
                </h:form>
            </div>
            <div style="height: 600px; overflow: auto">
                <h:form id="form-tabla-modulos">
                    <table jsf:id="elementos-tabla-modulo" class="ui basic selectable celled table" width="700px">
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>Modulo</th>
                                <th>Permisos</th>
                            </tr>
                        </thead>
                        <tbody>
                            <input jsf:id="idper" name="idper" type="hidden" jsf:value="#{permisoManBean.funcionarioVar.idfuncionario}"></input>
                            <ui:repeat value="#{permisoManBean.modulo}" var="modulos" varStatus="modulosStatus">
                                <tr id="mod#{modulos.idmodulo}">
                                    <td id="column-id-modulo-#{modulos.idmodulo}">#{modulos.idmodulo}</td>
                                    <td id="column-nombre-modulo-#{modulos.idmodulo}">#{modulos.nombre}</td>
                                    <td id="column-action-modulo">
                                        <h:commandLink id="btnModulo" action="#{permisoManBean.getFuncionalidadFromModulo(modulos.idmodulo)}" onclick="seleccionarModulo('#{modulos.idmodulo}')">
                                            <i class="settings icon"></i><f:ajax execute="@form" render="form-tabla-funcionalidad"/>
                                        </h:commandLink></td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                    </table>
                </h:form>
            </div>
            <div style="height: 600px; overflow: auto">
                <h:form id="form-tabla-funcionalidad">
                    <table jsf:id="elementos-tabla-funcionalidad" class="ui basic selected celled table" width="700px">
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>Funcionalidad</th>
                                <th>Estado</th>
                                <!--                            <th class="collapsing">
                                                                <div  class="ui fitted checkbox" onclick="seleccionarTodo()">
                                                                    <input type="checkbox" id="chk-selec-todo"/>
                                                                    <label/>
                                                                </div>
                                                            </th>-->
                            </tr>
                        </thead>
                        <tbody id="tbody-funcionalidad">

                            <ui:repeat value="#{permisoManBean.lstAux}" var="listaFuncionalidad" varStatus="listaFuncionalidadStatus">
                                <tr  class="#{listaFuncionalidad.estado?'active':'warning'}" id="fun#{listaFuncionalidad.idFuncionalidad}">
                                    <td id="col-id-funcionalidad-#{listaFuncionalidad.idFuncionalidad}">#{listaFuncionalidad.idFuncionalidad}</td>
                                    <td id="col-nombre-funcionalidad-#{listaFuncionalidad.idFuncionalidad}">#{listaFuncionalidad.nombre}</td>
                                    <td style="display: none" id="col-estado-funcionalidad-#{listaFuncionalidad.idFuncionalidad}">#{listaFuncionalidad.estado}</td>
                                    <td> 
                                        <div onclick="seleccionarFuncionalidadCheck(#{listaFuncionalidad.idFuncionalidad})" class="ui fitted checkbox">
                                            <input id="chk-fun-#{listaFuncionalidad.idFuncionalidad}" type="checkbox" checked="#{listaFuncionalidad.estado?'checked':''}" />
                                            <label></label>
                                        </div>
                                    </td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                        <div id="dim-tabla" class="ui inverted dimmer"/>
                    </table>
                </h:form>
                <div class="ui secondary menu">
                <h:form id="permisos-adm">
                    <input name="selbar1" id="selbar1" type="hidden" jsf:value="#{permisoManBean.seleccionIDJSON}"/>
                    <input name="selbar2" id="selbar2" type="hidden" jsf:value="#{permisoManBean.seleccionRemoverJSON}"/>
                    <input disabled="true" jsf:id="idfuncionario-value" name="idfuncionario-value" jsf:value="#{permisoManBean.funcionarioVar.idfuncionario}" type="hidden" readonly="true"></input>
                    <!--<input name="idmodulo" jsf:id="idmodulo" jsf:value=""/>-->
                    <h:inputHidden id="idfuncionario-hidden" value="#{permisoManBean.funcionarioVar.idfuncionario}" />
                    <h:inputHidden id="idModulo-hidden" value="#{permisoManBean.moduloVar.idmodulo}" />
                    <div class="actions">
                        <h:commandLink id="btn-guardar" onclick="generarDatos()" action="#{permisoManBean.administrarRegistro()}" actionListener="#{permisoManBean.administrarEliminarPermiso()}" class="ui right labeled teal icon button">
                            <i class="save icon"></i>
                            Guardar
                            <f:ajax execute="@form" onevent="function(data){ajaxGuardar(data)}" render="form-tabla-funcionalidad"/>
                        </h:commandLink>
                    </div>
                </h:form>
            </div>
            </div>
        </div>
          
        <script>
            $('#form-tabla-modulos').hide();
            $('#permisos-adm').hide();
            $('#form-tabla-funcionalidad').hide();
            $('#permisos-adm\\:idfuncionario-value').prop("disabled", true);
            $('#permisos-adm\\idfuncionario-value').prop("hidden", true);

            function seleccionarFuncionario(idFuncionario) {
                var idFun = '#func' + idFuncionario;
                $("#form-tabla tr").removeClass('active');
                $(idFun).addClass('active');
                if ($(idFun).hasClass('active')) {
                    $('#form-tabla-modulos').show();
                    $('#form-tabla-funcionalidad').hide();
                    $('#permisos-adm').hide();
                    $('#form-tabla-modulos tr').removeClass('active');
                    variableparam(idFuncionario);
                } else {
                    $('#form-tabla-modulos').hide();
                }
            }

            function seleccionarModulo(idmodulo) {
                var idMod = '#mod' + idmodulo;
                $('#form-tabla-modulos tr').removeClass('active');
                $(idMod).addClass('active');
                if ($(idMod).hasClass('active')) {
                    varaiableParametroModulo(idmodulo);
                    $('#permisos-adm\\:idModulo-hidden').val($('#column-id-modulo-' + idmodulo).html());
                    $('#permisos-adm').hide();
//                    $('#idmodulo').val($('#column-id-modulo-'+idmodulo).html());
                    $('#form-tabla-funcionalidad').show();
                } else {
                    $('#form-tabla-funcionalidad').hide();
                }
            }

            function btnCambiarPermisos() {
                var seleccionados = $('tbody :checkbox:checked').length;
                if (seleccionados > 0) {
                    $('#permisos-adm').show();
                } else {
                    $('#permisos-adm').hide();
                }
            }

//            function seleccionarFila(idfuncionalidad){
//                var idMod = '#fun' + idfuncionalidad;
//                var idchk = '#chk-fun-' + idfuncionalidad;
//                if($(idMod).hasClass('active')){
//                    $(idMod).removeClass('active');
//                    $(idchk).prop('checked', false);
//                    btnCambiarPermisos();
//                }else{
//                    $(idMod).addClass('active');
//                    $(idchk).prop('checked', true);
//                    btnCambiarPermisos();
//                }
//            }

            function seleccionarFuncionalidadCheck(idfuncionalidad) {
                var seleccionados = $('tbody :checkbox:checked').length;
                var idchk = '#chk-fun-' + idfuncionalidad;
                var idfila = '#fun' + idfuncionalidad;
                var estado = $('#col-estado-funcionalidad-' + idfuncionalidad).html();
                if ($(idchk).prop('checked')) {
                    $(idfila).addClass('active');
                    console.log(estado);
                    if (estado !== 'true') {
                        console.log("somos: ");
                        if (seleccionados > 0) {
                            console.log(seleccionados);
                            $('#permisos-adm').show();
                        } else if (seleccionados === 0) {
                            console.log(seleccionados);
                            $('#permisos-adm').hide();
                        }
                    } else {
                        console.log("era true");
                    }
                } else {
                    $(idfila).removeClass('active');
                    if (estado !== 'true') {
                        console.log(estado + ", remover fila");
                        if (seleccionados === 0) {
                            console.log(seleccionados);
                            $('#permisos-adm').hide();
                        }
                    } else if (estado === 'true') {
                        console.log(estado);
                        $('#permisos-adm').show();
                    }
                }
            }
            
            function ajaxGuardar(data){
                var s=data.status;
                switch(s){
                    case 'begin':{
                            $('#permisos-adm\\:btn-guardar').addClass('disabled');
                            $('#permisos-adm\\:btn-guardar').addClass('loading');
                            break;
                    }
                    case 'success':{
                            $('#permisos-adm\\:btn-guardar').removeClass('disabled');
                            $('#permisos-adm\\:btn-guardar').removeClass('loading');
                            break;
                    }
                }
            }

            function generarDatos() {
                var idSeleccionados = [];
                var idremover = [];
                $("tbody tr [id^='col-id-funcionalidad']").each(function (index, value) {
                    var id = parseInt($(this).html());
                    var estado = $('#col-estado-funcionalidad-' + id).html();
                    if ($('#chk-fun-' + id).prop('checked')) {
                        idSeleccionados.push(id);
                    } else {
                        if (estado) {
                            idremover.push(id);
                        } else {
                            idSeleccionados.push(id);
                        }
                    }
                });
                var jsonselect = JSON.stringify(idSeleccionados);
                $('#selbar1').val(jsonselect);
                var jremove = JSON.stringify(idremover);
                $('#selbar2').val(jremove);
            }


            function variableparam(idfuncionario) {
                $('#permisos-adm\\:idfuncionario-value').val($('#column-id-funcionario-' + idfuncionario).html());
                $('#permisos-adm\\:idfuncionario-hidden').val($('#column-id-funcionario-' + idfuncionario).html());
                $('#form-tabla-modulos\\:idper').val($('#column-id-funcionario-' + idfuncionario).html());
            }
            function varaiableParametroModulo(idmodulo) {
                $('#permisos-adm\\:idModulo-hidden').val($('#column-id-modulo-' + idmodulo).html());
            }
            $(document).ready(function () {
                $("#txtBuscar").keyup(function () {
                    if ($(this).val() !== "") {
                        $("#form-tabla\\:elementos-tabla tbody>tr").hide();
                        $("#form-tabla\\:elementos-tabla td:contains-ci('" + $(this).val() + "')").parent("tr").show();
                    } else {
                        $("#form-tabla\\:elementos-tabla tbody>tr").show();
                    }
                });
            });
            $.extend($.expr[":"], {
                "contains-ci": function (elem, i, match, array) {
                    return (elem.textContent || elem.innerText || $(elem).text() || "").toLowerCase().indexOf((match[3] || "").toLowerCase()) >= 0;
                }
            });
        </script>
    </ui:define>
</ui:composition>